package actores.behaviours;


import jade.core.Agent;
import jade.core.AID;
import jade.core.behaviours.*; 
import java.io.*;
import java.util.*;


import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

import java.util.Random;

import javax.sound.sampled.AudioFileFormat;
import javax.sound.sampled.Clip;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.SourceDataLine;

public class Musica extends Agent
 {
	private AID[] listaInvitados; 
	boolean tocar = true ;
	
	protected void setup()
	{	
		
		DFAgentDescription listadoInvitados = new DFAgentDescription();
		listadoInvitados.setName( getAID() );
		ServiceDescription sd = new ServiceDescription();
		sd.setType("party-orquesta");
		sd.setName( getLocalName() );
		listadoInvitados.addServices( sd );
		try 
		{
		  DFService.register(this, listadoInvitados);
		}
		catch (FIPAException fe) 
		{
		  fe.printStackTrace();
		}
	
		System.out.println("[Orquesta] " + getLocalName() + " esta disponible.");
	
	
		addBehaviour( new tocarMusica() );
      
   
	}//fin setup
	
	
	/** reproduccion de la musica **/
	private class tocarMusica extends CyclicBehaviour 
	{
	
		public void action() 
		{
		
		MessageTemplate mt = MessageTemplate.MatchPerformative(ACLMessage.REQUEST);
		ACLMessage mensaje = myAgent.receive(mt);
		  
		
		if (mensaje != null)
		{
		
			if (!mensaje.getContent().equals("stop"))
			{
				try
				{		
					
					System.out.println("[" + getLocalName() +"] Empieza a tocar musica. " );
												
					File f = new File( "mafia.wav" );
					AudioInputStream audio = AudioSystem.getAudioInputStream(f);
					AudioFormat format;
					format = audio.getFormat();
					SourceDataLine cancion;
					
					
					DataLine.Info info = new DataLine.Info(SourceDataLine.class, format);
					cancion = (SourceDataLine) AudioSystem.getLine(info);
					cancion.open(format);
					cancion.start();
					int nBytesRead = 0;
					byte[] abData = new byte[524288];
					while (nBytesRead != -1 && tocar ) 
					{
						nBytesRead = audio.read(abData, 0, abData.length);
						if (nBytesRead >= 0) 
						{
							cancion.write(abData, 0, nBytesRead);
						}
					}
					
					System.out.println("La orquesta huye tras recibir un chivatazo.");
					doWait( 1000 ) ;
					System.out.println("La gente se empieza a poner nerviosa.....");
				} 
				catch (Exception E) 
				{
					System.out.println(E.getMessage());

				}
			}
			else
			{
			
				try
				{		
					// addBehaviour( new disparar() );
					
					
					DFAgentDescription template = new DFAgentDescription();
					ServiceDescription sd = new ServiceDescription();
					sd.setType("party-guest");
					template.addServices(sd);
			  
				  try 
				  {
					DFAgentDescription[] result = DFService.search(myAgent, template); 
					
					
					listaInvitados = new AID[result.length];
					
						for (int i = 0; i < result.length; ++i)
						{
							listaInvitados[i] = result[i].getName();
							
							
							ACLMessage invitacion = new ACLMessage( ACLMessage.REQUEST );
							
							invitacion.addReceiver( listaInvitados[i] );
							invitacion.setContent( "disparo" );
							invitacion.setConversationId( "disparo" );
							invitacion.setReplyWith("disparo"+System.currentTimeMillis());
							myAgent.send( invitacion );
							
							// doWait( 3000 ) ;
						
						}	
									
						
				  }
					catch (FIPAException fe)
				  {
					fe.printStackTrace();
				  } 
				  
				  catch (Exception ex) 
				  { 
					ex.printStackTrace(); 
				  }
					
					System.out.println("=================================La policia rodea el restaurante=================================" );
												
					File f = new File( "sirena.wav" );
					AudioInputStream audio = AudioSystem.getAudioInputStream(f);
					AudioFormat format;
					format = audio.getFormat();
					SourceDataLine cancion;
					
					
					DataLine.Info info = new DataLine.Info(SourceDataLine.class, format);
					cancion = (SourceDataLine) AudioSystem.getLine(info);
					cancion.open(format);
					cancion.start();
					int nBytesRead = 0;
					byte[] abData = new byte[524288];
					while (nBytesRead != -1 ) 
					{
						nBytesRead = audio.read(abData, 0, abData.length);
						if (nBytesRead >= 0) 
						{
							cancion.write(abData, 0, nBytesRead);
						}
					}
					
					
					
					File f2 = new File( "manosarriba.wav" );
					AudioInputStream audio2 = AudioSystem.getAudioInputStream(f2);
					AudioFormat format2;
					format2 = audio2.getFormat();
					SourceDataLine cancion2;
					
					
					DataLine.Info info2 = new DataLine.Info(SourceDataLine.class, format2);
					cancion2 = (SourceDataLine) AudioSystem.getLine(info2);
					cancion2.open(format2);
					cancion2.start();
					int nBytesRead2 = 0;
					byte[] abData2 = new byte[524288];
					while (nBytesRead2 != -1 ) 
					{
						nBytesRead2 = audio2.read(abData2, 0, abData2.length);
						if (nBytesRead2 >= 0) 
						{
							cancion2.write(abData2, 0, nBytesRead2);
						}
					}
					
					
					
					File f3 = new File( "tiroteo.wav" );
					AudioInputStream audio3 = AudioSystem.getAudioInputStream(f3);
					AudioFormat format3;
					format3 = audio3.getFormat();
					SourceDataLine cancion3;
					
					
					DataLine.Info info3 = new DataLine.Info(SourceDataLine.class, format3);
					cancion3 = (SourceDataLine) AudioSystem.getLine(info3);
					cancion3.open(format3);
					cancion3.start();
					int nBytesRead3 = 0;
					byte[] abData3 = new byte[524288];
					while (nBytesRead3 != -1 ) 
					{
						nBytesRead3 = audio3.read(abData3, 0, abData3.length);
						if (nBytesRead3 >= 0) 
						{
							cancion3.write(abData3, 0, nBytesRead3);
						}
					}
					
				} 
				catch (Exception E) 
				{
					System.out.println(E.getMessage());

				}
			
			}
			
		}
		else
		{
			block();
		}
		}
		
	  
	}  //fin tocarMusica
	
	


	private class disparar extends OneShotBehaviour 
	{
	
				
		public void action()
		{			
			  DFAgentDescription template = new DFAgentDescription();
			  ServiceDescription sd = new ServiceDescription();
			  sd.setType("party-guest");
			  template.addServices(sd);
			  
			  try 
			  {
				DFAgentDescription[] result = DFService.search(myAgent, template); 
				
				
				listaInvitados = new AID[result.length];
				
					for (int i = 0; i < result.length; ++i)
					{
						listaInvitados[i] = result[i].getName();
												
						ACLMessage invitacion = new ACLMessage( ACLMessage.AGREE );
						
						invitacion.addReceiver( listaInvitados[i] );
						invitacion.setContent( "disparo" );
						invitacion.setConversationId( "disparo" );
						invitacion.setReplyWith("disparo"+System.currentTimeMillis());
						myAgent.send( invitacion );
					}	
								
					
			  }
				catch (FIPAException fe)
			  {
				fe.printStackTrace();
			  } 
			  
			  catch (Exception ex) 
			  { 
				ex.printStackTrace(); 
			  }
			
			 
		}
		
	}//fin
	
	
	
}